#!/bin/sh

# $Id: memory.sh,v 1.6 2004/09/18 20:10:58 pho Exp $

psize=`sysctl hw.pagesize | sed 's/.* //'`
kvm=`swapinfo -k | tail -1 | awk '{print $2}'`
[ $kvm = "1K-blocks" ] && kvm=0
swap=$kvm
kvm=`expr $kvm \* 1024`
kvm=`expr $kvm / $psize`

ram=`sysctl hw.usermem | sed 's/.* //'`
ram=`expr $ram / $psize`

kvm=`expr $kvm + $ram`
kvm=`expr $kvm / 2`	# Do not use more than 50%

if [ $swap -eq 0 ]; then
   size=`../random/random 512 $ram`
else
   size=`../random/random 512 $kvm $ram`
   [ $# -eq 1 ] && [ $1 = "hog" ] && size=$kvm
fi
#echo "ram = $ram, kvm = $kvm, size = $size"

sleep `../random/random 1 10`
n=`../random/random 10 20`
m=$n

size=`expr $size / $n`
while [ $n -gt 0 ]; do
   n=`expr $n - 1`
   ./memory -s $size `../random/random 30 60` &
done

while [ $m -gt 0 ]; do
   m=`expr $m - 1`
   wait
done
