#!/bin/sh

# $Id: run.sh,v 1.3 2004/10/17 07:31:22 pho Exp $

# Main stress test shell script.

# in /etc/inetd.conf discard must be configured:
#discard stream	tcp	nowait	root	internal

BLASTHOST=192.168.1.2	#Change this!!
export BLASTHOST


tests="\
badcode \
crashme \
creat \
df \
dir \
fork \
libthr \
longjmp \
maxpath \
memory \
net \
pthread \
pthread2 \
rw \
shm \
syscall \
sysctl \
tcpblast \
yield \
"


i=1
while true; do
   date
   /bin/echo "Loop #$i ...\c"
   for t in $tests; do
      (cd $t; ./$t.sh) &
   done
   for t in $tests; do
      wait
   done
   /bin/echo ""
   i=`expr $i + 1`
done
