#!/bin/sh

# $Id$

for i in `find /var/crash/vmcore.*`; do
   (
   echo "set pagination off"
   echo "vn"
   echo "bt"
   ) > /tmp/input

   n=`echo $i | sed 's/.*\.//'`
   [ -r /var/crash/stack.$n ] && continue
   kernel=`strings $i | egrep "^FreeBSD.*#.*@" | head -1 | sed 's/.*://'`
   cd $kernel
   gdb -k -q -batch -x /tmp/input kernel.debug $i > /var/crash/stack.$n 2>/dev/null


   l=`grep "instruction pointer" /var/crash/stack.$n`
   [  -z "$l" ] && continue

   (
   echo "set pagination off"
   echo "vn"
   ) > /tmp/input

   addr=`echo $l | sed 's/.*://'` 
   echo "echo \"exception pointer: \"" >> /tmp/input
   echo "x/i $addr" >> /tmp/input
   echo "l *$addr" >> /tmp/input
   echo "bt" >> /tmp/input

   gdb -k -q -batch -x /tmp/input kernel.debug $i > /var/crash/stack.$n 2>/dev/null
   rm -f /tmp/input
done
