/* $Id$ */

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <err.h>
#include <strings.h>
#include <sys/wait.h>

char buf[4096];

void
handler(int i) {
	exit(0);
}

int
test(void) {
	pid_t r;
	int status;

	for (;;) {
		r = fork();
		if (r == 0) {
			bzero(buf, sizeof(buf));
			exit(0); /*child dies */
		}
		if (r < 0) {
			perror("fork");
			exit(2);
		}
		wait(&status);
	}
	return 0;
}

int main(int argc, char **argv)
{
	int i;
	
	i = 0;
	signal(SIGALRM, handler);
	alarm(60);


	return test();
}
