#!/bin/sh

# $Id: psize,v 1.6 2001/03/01 11:04:18 pho Exp $

# trace kernal allocation of dev_t in makedev

trap "echo ''; exit" 0 1

number=0
size=0
printf "%16s %7s\n" number "size K"
while true;do
   s=`vmstat -m | grep dev_t | sed "s/  / /g;s/K / /"`
   set $s
   ts=`date +"%H:%M.%S"`
   if [ $number -ne $2 ] || [ $size -ne $3 ]; then
      number=$2
      size=$3
      printf "%s %7s %7s\n" $ts ${number} ${size}
   else
      echo -e "$ts\r\c"
   fi      
   sleep 1
done
